//
//  AngleViewController.swift
//  Winkel
//
//  Created by Heiko Etzold on 31.03.20.
//  Copyright © 2020 Heiko Etzold. All rights reserved.
//

import UIKit

class AngleViewController: UIViewController {

    var angleView =  AngleView()
    var currentStateOfTask = Int(0)
    var stateOfCheckButton = "check"
    var score = Double(0)


    override func viewDidLoad() {
        super.viewDidLoad()

        angleView.colorOfLines = labelColor
    }
    
    override func viewDidAppear(_ animated: Bool) {
        //change line length for iPhone
        if(UIDevice.current.userInterfaceIdiom == .phone){
            angleView.lengthOfLine = min(angleView.bounds.width,angleView.bounds.height)/2-1.25*angleView.touchPoint.touchPointRadius-10
        }

        //redraw the angle
        angleView.redrawAngle(offset: angleView.offsetAngle, size: angleView.sizeOfAngle)
    }
    
    
    //change between identify an adjust
    @IBAction func changeReadAndDraw(_ sender: UISegmentedControl) {
        currentStateOfTask = sender.selectedSegmentIndex
        newTask()
    }

    
    func newTask() {
    }
    
    
    //create touch points
    func initTouchPoint(){
        angleView.touchPoint = TouchPointForAngleView(connectedAngleViewController: self)
        angleView.touchPoint.alpha = 0
        angleView.addSubview(angleView.touchPoint)

        //set task to adjust when using iPhone
        if(UIDevice.current.userInterfaceIdiom == .phone){
            currentStateOfTask = 1
        }
    }

    
    //update view, when Mac-window is resized
    override func viewWillTransition(to size: CGSize, with coordinator: UIViewControllerTransitionCoordinator) {
        if(angleView.touchPoint != nil){
            angleView.redrawAngle(offset: angleView.offsetAngle, size: angleView.sizeOfAngle)
        }
    }
}
