//
//  TouchPointForAngleView.swift
//  Winkel
//
//  Created by Heiko Etzold on 17.02.18.
//  Copyright © 2018 Heiko Etzold. All rights reserved.
//

import UIKit

class TouchPointForAngleView: TouchPoint {

    
    var connectedAngleViewController = AngleViewController()
    
    init(connectedAngleViewController: AngleViewController) {
        super.init(position: CGPoint.zero, connectedViewController: UIViewController(), small: false)
        
        self.connectedAngleViewController = connectedAngleViewController
        createTouchPoint(small: false)
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    var offsetLocation = CGPoint.zero

    //keep touch point on circle
    override func touchesMoved(_ touches: Set<UITouch>, with event: UIEvent?) {
        self.center += (touches.first?.location(in: self))!-(touches.first?.previousLocation(in: self))!
        let direction = self.center-connectedAngleViewController.angleView.convert(connectedAngleViewController.angleView.center, from: connectedAngleViewController.angleView.superview)
        let positionAngle = atan2(direction.y, direction.x)
        self.center = connectedAngleViewController.angleView.convert(connectedAngleViewController.angleView.center, from: connectedAngleViewController.angleView.superview)+CGPoint(x: connectedAngleViewController.angleView.lengthOfLine*cos(positionAngle), y: connectedAngleViewController.angleView.lengthOfLine*sin(positionAngle))

        let calculatedPosition = -positionAngle-connectedAngleViewController.angleView.offsetAngle*(.pi)/180
        let newAngle = round((connectedAngleViewController.angleView.sizeOfAngle-calculatedPosition*180/(.pi))/360)*360+calculatedPosition*180/(.pi)
        connectedAngleViewController.angleView.redrawAngle(offset: connectedAngleViewController.angleView.offsetAngle, size: newAngle)
        if(connectedAngleViewController.angleView.sizeOfAngle < 0){
            connectedAngleViewController.angleView.redrawAngle(offset: connectedAngleViewController.angleView.offsetAngle, size: 0)
        }
        if(connectedAngleViewController.angleView.sizeOfAngle > 360){
            connectedAngleViewController.angleView.redrawAngle(offset: connectedAngleViewController.angleView.offsetAngle, size: 360)
        }
    }

}
